controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Competencias;
use app\models\DatosPersonales;
use app\models\Estudios;
use app\models\Experiencia;
use app\models\Funciones;
use app\models\Otros;
use yii\data\ActiveDataProvider;
use kartik\mpdf\Pdf;
use yii\web\UploadedFile;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionPerfil()
    {
        $model=DatosPersonales::find()->one();
        return $this->render('perfil',["model" => $model]);
    }
    
    public function actionAcademica()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Estudios::find()->where(["complementarios" => 0])]);
        return $this->render("academica",["dataProvider" => $dataProvider, "titulo" => "Formación Académica"]);        
    }
    
    public function actionComplementaria()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Estudios::find()->where(["complementarios" => 1])]);
        return $this->render("academica",["dataProvider" => $dataProvider, "titulo" => "Formación Complementaria"]);        
    }
    
    public function actionExperiencia()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Experiencia::find()]);
        return $this->render("experiencia",["dataProvider" => $dataProvider]);    
    }
    
    public function actionOtros()
    {
        $tipos= Otros::find()->select(["tipo"])->distinct()->all();
        return $this->render("otros",["tipos" => $tipos]); 
    }
    
    public function actionPdf()
    {
        
        // get your HTML raw content without any layouts or scripts
        $model=DatosPersonales::find()->one();
        $formacion= Estudios::find()->where(["complementarios" => 0]);
        $dataProviderFormacion = new ActiveDataProvider([
        'query' => $formacion]);
        $complementaria= Estudios::find()->where(["complementarios" => 1]);
        $dataProviderComplementaria = new ActiveDataProvider([
        'query' => $complementaria]);
        $dataProviderExperiencia= new ActiveDataProvider([
        'query' => Experiencia::find()]);
        $tipos= Otros::find()->select(["tipo"])->distinct()->all();
        $content = $this->renderPartial('pdf',[  //renderPartial renderiza sin mostrar el layout
            "model" => $model,
            "formacion" => $dataProviderFormacion,
            "complementaria" => $dataProviderComplementaria,
            "experiencia" => $dataProviderExperiencia,
            "tipos" => $tipos,
                ]);  

        // setup kartik\mpdf\Pdf component
        $pdf = new Pdf([
            // set to use core fonts only
            'mode' => Pdf::MODE_CORE, 
            // A4 paper format
            'format' => Pdf::FORMAT_A4, 
            // portrait orientation
            'orientation' => Pdf::ORIENT_PORTRAIT, 
            // stream to browser inline
            'destination' => Pdf::DEST_BROWSER, 
            // your html content input
            'content' => $content,  
            // format content from your own css file if needed or use the
            // enhanced bootstrap css built by Krajee for mPDF formatting 
            'cssFile' => ['@app/web/css/kv-mpdf-bootstrap.css','@app/web/css/site.css']
,
            // any css to be embedded if required
            'cssInline' => '.kv-heading-1{font-size:18px}', 
             // set mPDF properties on the fly
            'options' => ['title' => 'Krajee Report Title'],
             // call mPDF methods on the fly
            'methods' => [ 
                'SetHeader'=>['Diego Méndez Álvarez'], 
                'SetFooter'=>['{PAGENO}'],
            ]
        ]);

        // return the pdf output as per the destination setting
        return $pdf->render(); 
    }
    
    public function actionEditardatospersonales()
    {
        $model= DatosPersonales::find()->one();
        $foto_antigua=$model->foto;

    if ($model->load(Yii::$app->request->post())) {
        if ($model->validate()) 
        {
            $model->foto=UploadedFile::getInstance($model,"foto");
            
            if($model->foto==null)
            {
                $model->foto=$foto_antigua;
            }else
            {
                $model->foto->saveAs('imgs/' . $model->foto->name);
                unlink("../web/imgs/" . $foto_antigua);
                $model->foto=$model->foto->name;
            }
            
            $model->save();
            return $this->redirect(["site/perfil"]);
            
            
        }
    }

    return $this->render('formulario_datospersonales', [
        'model' => $model,
    ]);
    }
    
    public function actionAnadirestudios($formacion)
    {
        $model = new Estudios();

    if ($model->load(Yii::$app->request->post())) {
        if ($model->validate()) {
            $model->complementarios=$formacion;
            $model->save();
            if($formacion)
            {
                return $this->redirect(["site/complementaria"]);
            }else
            {
                return $this->redirect(["site/academica"]);
            }
        }
    }

    return $this->render('formulario_estudios', [
        'model' => $model,
        'boton' => 'Añadir',
    ]);
    }
    
    public function actionActualizarestudios($id)
    {
        $model = Estudios::findOne($id);

    if ($model->load(Yii::$app->request->post())) {
        if ($model->validate()) {
            $model->save();
            if($model->complementarios)
            {
                return $this->redirect(["site/complementaria"]);
            }else
            {
                return $this->redirect(["site/academica"]);
            }
        }
    }

    return $this->render('formulario_estudios', [
        'model' => $model,
        'boton' => 'Actualizar'
    ]);
    }
    
    public function actionEliminarestudios($id)
    {
        $model = Estudios::findOne($id);
        $model->delete();
        if($model->complementarios)
        {
            return $this->redirect(["site/complementaria"]);
        }else
        {
            return $this->redirect(["site/academica"]);
        }
        
    }
    
    public function actionAnadircompetencias($id_estudios,$formacion)
    {
        $model = new Competencias();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) 
            {
                $model->id_estudios=$id_estudios;
                $model->save();
                if($formacion)
                {
                    return $this->redirect(["site/complementaria"]);
                }else
                {
                    return $this->redirect(["site/academica"]);
                }
            }
        }

        return $this->render('formulario_competencias', [
            'model' => $model,
            'boton' => 'Añadir',
        ]);
    }
    
    public function actionActualizarcompetencias($id,$formacion)
    {
        $model = Competencias::findOne($id);

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) 
            {
                $model->save();
                if($formacion)
                {
                    return $this->redirect(["site/complementaria"]);
                }else
                {
                    return $this->redirect(["site/academica"]);
                }
            }
        }

        return $this->render('formulario_competencias', [
            'model' => $model,
            'boton' => 'Actualizar',
        ]);
    }
    
    public function actionEliminarcompetencias($id,$formacion)
    {
        $model = Competencias::findOne($id);
        $model->delete();
        
        if($formacion)
        {
            return $this->redirect(["site/complementaria"]);
        }else
        {
            return $this->redirect(["site/academica"]);
        }
    }
    
    public function actionAnadirexperiencia()
    {
        $model = new Experiencia();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) 
            {
                $model->save();
                return $this->redirect(["site/experiencia"]);
            }
        }

        return $this->render('formulario_experiencia', [
            'model' => $model,
            'boton' => 'Añadir',
        ]);
    }
    
    public function actionActualizarexperiencia($id)
    {
        $model = Experiencia::findOne($id);

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) 
            {
                $model->save();
                return $this->redirect(["site/experiencia"]);
            }
        }

views/site/_otros.php
<?php
use yii\helpers\Html;

echo $model->nombre . " " . $model->nivel . " " .
        Html::a('<i class="fas fa-pen"></i>',["site/actualizarotros","id" => $model->id]) . " " .
        Html::a('<i class="fas fa-trash-alt"></i>',["site/eliminarotros","id" => $model->id],
            ['data' => [
            'confirm' => '¿Estas seguro que deseas eliminar este dato?',
            'method' => 'post',
        ],
                ]);

views/site/academica.php
<?php
use yii\widgets\ListView;
use yii\helpers\Html;
?>

<div>
    <h2><?= $titulo ?></h2>
</div>

<?php

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_academica',
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'caja',
    ],
    'layout'=>"{items}"

    ]);

if($titulo=="Formación Académica")
{
    $formacion=0;
}else
{
   $formacion=1; 
}
echo Html::a('Añadir estudios',["site/anadirestudios","formacion" =>$formacion], ['class' => 'btn btn-primary float-right']);

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/experiencia.php
<?php
use yii\widgets\ListView;
use yii\helpers\Html;
?>

<?php

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_experiencia',
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'caja',
    ],
    'layout'=>"{items}"

    ]);

echo Html::a('Añadir experiencia',["site/anadirexperiencia"], ['class' => 'btn btn-primary float-right']);

views/site/formulario_competencias.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Competencias */
/* @var $form ActiveForm */
?>
<div class="site-formulario_competencias">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'descripcion') ?>
    
        <div class="form-group">
            <?= Html::submitButton($boton, ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario_competencias -->

views/site/formulario_datospersonales.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\DatosPersonales */
/* @var $form ActiveForm */
?>
<div class="formulario_datospersonales">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'carnet_de_conducir')->checkbox() ?>
        <?= $form->field($model, 'nombre') ?>
        <?= $form->field($model, 'apellidos') ?>
        <?= $form->field($model, 'email') ?>
        <?= $form->field($model, 'telefono') ?>
        <?= $form->field($model, 'direccion') ?>
        <?= $form->field($model, 'foto')->fileInput() ?>
    
        <div class="form-group">
            <?= Html::submitButton('Editar', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- formulario_datospersonales -->

views/site/formulario_estudios.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Estudios */
/* @var $form ActiveForm */
?>
<div class="site-formulario_estudios">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'titulo') ?>
        <?= $form->field($model, 'fechas') ?>
        <?= $form->field($model, 'centro') ?>
    
        <div class="form-group">
            <?= Html::submitButton($boton, ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario_estudios -->

views/site/formulario_experiencia.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Experiencia */
/* @var $form ActiveForm */
?>
<div class="site-formulario_experiencia">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'fechas') ?>
        <?= $form->field($model, 'empresa') ?>
        <?= $form->field($model, 'puesto') ?>
        <?= $form->field($model, 'poblacion') ?>
    
        <div class="form-group">
            <?= Html::submitButton($boton, ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario_experiencia -->

views/site/formulario_funciones.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Funciones */
/* @var $form ActiveForm */
?>
<div class="site-formulario_funciones">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'descripcion') ?>
    
        <div class="form-group">
            <?= Html::submitButton($boton, ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario_funciones -->

views/site/formulario_otros.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Otros */
/* @var $form ActiveForm */
?>
<div class="site-formulario_otros">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'nombre') ?>
        <?= $form->field($model, 'nivel') ?>
        <?= $form->field($model, 'tipo') ?>
    
        <div class="form-group">
            <?= Html::submitButton($boton, ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario_otros -->

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">Curriculum Diego Méndez Álvarez</h1>
    </div>
</div>

views/site/otros.php
<?php
use app\models\Otros;
use yii\widgets\ListView;
use yii\data\ActiveDataProvider;
use yii\helpers\Html;

foreach($tipos as $tipo)
{
    echo "<div style='background-color: #ddd'>";
    echo "<h2>$tipo->tipo</h2>";
    
    $dataProvider= Otros::getConsulta($tipo->tipo);
    
    echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_otros',
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    'layout'=>"{items}"
    ]);
    
    echo "</div>";
}

echo Html::a('Añadir otros datos',["site/anadirotros"], ['class' => 'btn btn-primary float-right']);
?>

views/site/perfil.php
<?php
use app\widgets\Card;
use yii\helpers\Html;
?>
<div class="row">

    <div class="col-lg-6">
<?php

echo Card::widget([
    //"titulo" => "Imagen",
    "contenido" => Html::img("@web/imgs/$model->foto",["class"=>"img-fluid","width"=>100,"height"=>200]),
]);
        
echo Card::widget([
    "titulo" => "Nombre Completo",
    "contenido" => $model->getNombreCompleto(),
]);

?>
    </div>
    <div >
<?php        
echo Card::widget([
    "titulo" => "Direccion",
    "contenido" => $model->direccion,
]);

echo Card::widget([
    "titulo" => "Correo Electrónico",
    "contenido" => $model->email,
]);

echo Card::widget([
    "titulo" => "Teléfono",
    "contenido" => $model->telefono,
]);

if($model->carnet_de_conducir)
{
    echo Card::widget([
    "titulo" => "Carnet de conducir",
    "contenido" => "Si",
]);
}

echo Html::a("Editar datos personales",["site/editardatospersonales"], ['class' => 'btn btn-primary float-right']);
?>
    </div>
    
</div>

views/site/prueba.php
<?php

echo "prueba";